#include <bits/stdc++.h>
using namespace std;
int main(){
long long n,k,suma,mod=pow(10,9)+7;
cin>>n>>k;
long long niz[n];
for(int i=0; i<n; i++){
    cin>>niz[i];
}
if(k==0){
    for(int i=0; i<n; i++){
        suma+=niz[i];
        suma=suma%mod;
    }
}
else if(k==1){
    for(int i=0; i<n; i++){
        suma+=(n-i)*niz[i]*(i+1);
        suma=suma%mod;
    }
}
cout<<suma-1;
return 0;
}